# 第2节 基于element的使用文档


### 2.1 前期准备

    因布局器的页面代码需要持久化到本地数据库，所以您可以参考一下方式 把布局器数据保存和初始化
    打开callback.js 可以看到


    /**
     * 初始化布局器成功后执行：您可以调用api.insert(html,javascript)来初始化布局器的默认数据
     * @param api 接口api对象 具体方法参考api.js
     */
    MagicalCallback.prototype.after_start = function (api) {
        $.get("您的服务器后端地址",{pageId:从页面地址获取一个参数},function(data){
                //方式1 如果您使用html方式来回初始化和保存
                api.insert(data.html,data.javascript);//api请参考api.js文件
                //方式2 如果您使用rootNode来回初始化和保存
                api.insertNode(JSON.parse(data.rootNode));
                api.insertJavascript(data.javascript);
        })
    }


    /**
     * 保存按钮
     * @param html 源码部分
     * @param rootNode 当前布局器JSON 这个数据您可以选择不保存 因为只有html足够初始化和还原布局器了
     * @param javascript 脚本
     */
    MagicalCallback.prototype.save_html = function (html,rootNode,javascript) {
        //方式一 保存html
        $.post("您的服务器后端地址",{pageId:从页面地址获取一个参数,html:html,javascript:javascript},function(data){
                api.insert(data.html,data.javascript);//api请参考api.js文件
        })
        //方式二 保存rootNode json 不建议您保存json来初始化 因为json非常大 而html是必须要保存的 用于后续脱离布局器单独部署页面
         $.post("您的服务器后端地址",{pageId:从页面地址获取一个参数,html:JSON.stringify(rootNode),javascript:javascript},function(data){
                api.insert(data.html,data.javascript);//api请参考api.js文件
        })
    }



### 2.2 数据库实体

page:页面

| 字段名   | 字段类型 | 注释     |
| -------- | -------- | -------- |
| id       | bigint   | 页面id   |
| pageHtml | longtext | 页面HTML |
| pageJs   | longtext | 页面脚本 |

建表语句(mysql)

    CREATE TABLE `page` (
      `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键',
      `page_html` longtext COMMENT '页面HTML',
      `page_js` longtext COMMENT '页面js',
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4;


### 2.3 后端接口(可参考 集成示例magicaldemo for java)

    1 保存页面数据 POST deployer/project/save_page?id=1&pageHtml=xxx&pageJs=xxx
      /**
       *  id为空则insert数据库 否则update数据库
       * @param {id:页面id,pageHtml:页面html,pageJs:页面脚本}
       */
    2 获取页面数据 GET deployer/project/page/{pageId}
    /**
     * 布局器加载后需要调用此方法 恢复布局器数据
     * @param pageId
     * @return {flag:true,data:{pageHtml:'',pageJs:''}}
     */


### 2.4 页面流程

    首先您需要知道 layui暂不支持可视化脚本布局器，所以相对简单很多，您需要关注页面加载流程
        1 自己业务先建立一个页面 拿到页面主键 pageId
        2 跳转到布局器，地址参数携带此pageId 例如 http://xxx/magicaldrag/index-page.html?pageId=123
    
        3 当index-page.html加载完毕
                        |
                     会自动调用
                        |
         magicaldrag/assets/drag/js/user/callback.js
                        |
         进入after_start(api) 布局器加载完后会调用此方法 您可以在此处初始化上一次的数据
                        |
                    自行提供后端接口保存和初始化
                        |
                    如果您点击了保存按钮
                        |
                则自动进入callback.js的save_html方法


### 2.5 文件上传

#### 2.5.1 平台

### 2.6 自定义组件各类示例(陆续添加中)

#### 示例一



    此为markdown文档，请使用Typora软件访问 或者支持markdown的软件皆可
